## libphonenumber 8.13.51+ds

=== cpp/CMakeLists.txt ===
# Copyright (C) 2011 The Libphonenumber Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Author: Philippe Liard

cmake_minimum_required (VERSION 3.11)

project (libphonenumber VERSION 8.13.0)

if (32BIT)
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m32")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m32")
  set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -m32")
  set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -m32")
endif ()

# Set out-of-tree tools directory
set (TOOLS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../tools/cpp")
set (TOOLS_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/tools")

# Helper functions dealing with finding libraries and programs this library
# depends on.

include (FetchContent)
include (GNUInstallDirs)

function (print_error DESCRIPTION FILE)
  message (FATAL_ERROR
    "Can't find ${DESCRIPTION}: can't locate ${FILE}. Please read the README.")
endfunction ()

# Find a library. If it has not been found, stop CMake with a fatal error
# message.
function (find_required_library NAME HEADER LIBRARY DESCRIPTION)
  # Check the header.
  find_path (${NAME}_INCLUDE_DIR ${HEADER})
  set (INCLUDE_DIR ${${NAME}_INCLUDE_DIR})

  if (${INCLUDE_DIR} STREQUAL "${INCLUDE_DIR}-NOTFOUND")
    print_error (${DESCRIPTION} ${HEADER})
  endif ()
  include_directories (${INCLUDE_DIR})
  # Check the binary.
  find_library (${NAME}_LIB ${LIBRARY})
  set (LIB ${NAME}_LIB)

  if (${LIB} STREQUAL "${LIB}-NOTFOUND")
    print_error (${DESCRIPTION} ${LIBRARY})
  endif ()
endfunction (find_required_library)

# Check the library version (if pkg-config available).
find_package (PkgConfig)
function (check_library_version VARNAME LIBRARY_WITH_VERSION)
  if (PKG_CONFIG_FOUND)
    pkg_check_modules (${VARNAME} ${LIBRARY_WITH_VERSION})
  endif ()
endfunction ()

# Find a program. If it has not been found, stop CMake with a fatal error
# message.
function (find_required_program NAME FILENAME DESCRIPTION)
  find_program (${NAME}_BIN NAMES ${FILENAME})

  if (${NAME}_BIN STREQUAL "${NAME}_BIN-NOTFOUND")
    print_error (${DESCRIPTION} ${FILENAME})
  endif ()
endfunction (find_required_program)

# Options that can be passed to CMake using 'cmake -DKEY=VALUE'.
option (BUILD_GEOCODER "Build the offline phone number geocoder" ON)
option (REGENERATE_METADATA "Regenerate metadata instead of using it from the source tree" ON)
option (USE_ALTERNATE_FORMATS "Use alternate formats" ON)
option (USE_PROTOBUF_LITE "Link to protobuf-lite" OFF)
option (USE_BOOST "Use Boost" ON)
option (USE_ICU_REGEXP "Use ICU regexp engine" ON)
option (USE_LITE_METADATA "Use lite metadata" OFF)
option (USE_RE2 "Use RE2" OFF)
option (USE_STD_MAP "Force the use of std::map" OFF)
option (BUILD_STATIC_LIB "Build static libraries" ON)
option (BUILD_SHARED_LIBS "Build shared libraries" ON)
option (BUILD_TESTING "Build testing" ON)
option (BUILD_TOOLS_ONLY "Limit build to targets in ../tools/cpp" OFF)
option (USE_STDMUTEX "Use C++ 2011 std::mutex for multi-threading" OFF)
option (USE_POSIX_THREAD "Use Posix api for multi-threading" OFF)

if (USE_ALTERNATE_FORMATS)
  add_definitions ("-DI18N_PHONENUMBERS_USE_ALTERNATE_FORMATS")
endif ()

# Find all the required libraries and programs.
find_package(absl)

if(NOT absl_FOUND)
  # Overide abseil install rules for subprojects
  set(ABSL_ENABLE_INSTALL ON)
  
  # Downloading the abseil sources at particular version to not catch up
  # with its new build requirements like min C++14 is mandated in that lib.
  FetchContent_Declare(
      abseil-cpp
      GIT_REPOSITORY  https://github.com/abseil/abseil-cpp.git
      GIT_TAG         273292d
  )

  # Building the abseil binaries
  FetchContent_GetProperties(abseil-cpp)
  if (NOT abseil-cpp_POPULATED)
      FetchContent_Populate(abseil-cpp)
  endif ()

  if (NOT abseil-cpp_POPULATED)
     message (FATAL_ERROR "Could not build abseil-cpp binaries.")
  endif ()

  # Safeguarding against any potential link errors as mentioned in
  # https://github.com/abseil/abseil-cpp/issues/225
  set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
  add_subdirectory(${abseil-cpp_SOURCE_DIR} ${abseil-cpp_BINARY_DIR})
endif()

if (BUILD_TESTING)
  include (../tools/cpp/gtest.cmake)
  find_or_build_gtest ()
endif()

if (BUILD_TOOLS_ONLY)
  add_subdirectory("${TOOLS_DIR}" "${TOOLS_BINARY_DIR}")
  return()
endif()

if (USE_BOOST)
  add_definitions ("-DI18N_PHONENUMBERS_USE_BOOST")
  if (WIN32)
    set (Boost_USE_STATIC_LIBS ON)
  endif ()
  find_package (Boost 1.40.0 COMPONENTS date_time system thread)
  if (NOT Boost_FOUND)
    print_error ("Boost Date_Time/System/Thread" "Boost")
  endif ()
  include_directories (${Boost_INCLUDE_DIRS})
endif ()

if (USE_STDMUTEX)
  add_definitions ("-DI18N_PHONENUMBERS_USE_STDMUTEX")
endif ()

if (USE_POSIX_THREAD)
  add_definitions ("-DI18N_PHONENUMBERS_HAVE_POSIX_THREAD")
  find_package (Threads REQUIRED)
endif ()

if ((NOT USE_BOOST) AND (NOT USE_STDMUTEX))
  find_package (Threads)
endif()

if (USE_RE2)
  find_required_library (RE2 re2/re2.h re2 "Google RE2")
endif ()

if (USE_PROTOBUF_LITE)
  find_required_library (PROTOBUF google/protobuf/message_lite.h protobuf-lite
                         "Google Protocol Buffers")
  check_library_version (PC_PROTOBUF protobuf-lite>=2.4)
else ()
  find_required_library (PROTOBUF google/protobuf/message_lite.h protobuf
                         "Google Protocol Buffers")
  check_library_version (PC_PROTOBUF protobuf>=2.4)
endif ()

find_required_library (ICU_UC unicode/uchar.h icuuc "ICU")
check_library_version (PC_ICU_UC icu-uc>=4.4)

set (ICU_INCLUDE_DIR ${ICU_UC_INCLUDE_DIR})
set (ICU_LIB ${ICU_UC_LIB})
# If ICU regexp engine is used or if the geocoder is built, use icui18n as well.
if (USE_ICU_REGEXP OR BUILD_GEOCODER)
  find_required_library (ICU_I18N unicode/regex.h icui18n "ICU")
  check_library_version (PC_ICU_I18N icu-i18n>=4.4)
  list (APPEND ICU_INCLUDE_DIR ${ICU_I18N_INCLUDE_DIR})
  list (APPEND ICU_LIB ${ICU_I18N_LIB})
endif ()

find_required_program (PROTOC protoc
                       "Google Protocol Buffers compiler (protoc)")

if (REGENERATE_METADATA)
  find_required_program (JAVA java
                         "Java Runtime Environment")
endif ()

if (APPLE)
  FIND_LIBRARY (COREFOUNDATION_LIB CoreFoundation)
  FIND_LIBRARY (FOUNDATION_LIB Foundation)
  set (CMAKE_MACOSX_RPATH OFF)
  set (CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS
    "${CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS} -undefined dynamic_lookup")
endif ()

if (NOT USE_STD_MAP)
  INCLUDE (CheckIncludeFileCXX)
  CHECK_INCLUDE_FILE_CXX ("tr1/unordered_map" HAVE_CXX_TR1_UNORDERED_MAP)
  if (HAVE_CXX_TR1_UNORDERED_MAP)
    add_definitions ("-DI18N_PHONENUMBERS_USE_TR1_UNORDERED_MAP")
  endif ()
endif ()

# Add protoc (Protocol Buffers compiler) target.
set (RESOURCES_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../resources")

set (
  PROTOBUF_SOURCES "${RESOURCES_DIR}/phonemetadata.proto"
                   "${RESOURCES_DIR}/phonenumber.proto"
)

set (
  PROTOBUF_OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/src/phonenumbers/phonemetadata.pb.cc"
                  "${CMAKE_CURRENT_SOURCE_DIR}/src/phonenumbers/phonemetadata.pb.h"
                  "${CMAKE_CURRENT_SOURCE_DIR}/src/phonenumbers/phonenumber.pb.cc"
                  "${CMAKE_CURRENT_SOURCE_DIR}/src/phonenumbers/phonenumber.pb.h"
)

add_custom_command (
  COMMAND ${PROTOC_BIN} --cpp_out=${CMAKE_CURRENT_SOURCE_DIR}/src/phonenumbers/
    --proto_path=${RESOURCES_DIR} ${PROTOBUF_SOURCES}

  OUTPUT ${PROTOBUF_OUTPUT}
  DEPENDS ${PROTOBUF_SOURCES}
)

if (BUILD_GEOCODER)
  # Geocoding data cpp file generation
  add_subdirectory("${TOOLS_DIR}" "${TOOLS_BINARY_DIR}")

  set (GEOCODING_DIR "${RESOURCES_DIR}/geocoding")
  file (GLOB_RECURSE GEOCODING_SOURCES "${GEOCODING_DIR}/*.txt")

  set (GEOCODING_DATA_OUTPUT
    "${CMAKE_CURRENT_SOURCE_DIR}/src/phonenumbers/geocoding/geocoding_data.cc"
  )

  add_custom_command (
    COMMAND generate_geocoding_data "${GEOCODING_DIR}"
      "${GEOCODING_DATA_OUTPUT}"

    OUTPUT ${GEOCODING_DATA_OUTPUT}
    DEPENDS ${GEOCODING_SOURCES}
            generate_geocoding_data
    COMMENT "Generating geocoding data code"
  )
endif ()

set (
  SOURCES
  "src/phonenumbers/asyoutypeformatter.cc"
  "src/phonenumbers/base/strings/string_piece.cc"
  "src/phonenumbers/default_logger.cc"
  "src/phonenumbers/logger.cc"
  "src/phonenumbers/phonemetadata.pb.cc" # Generated by Protocol Buffers.
  "src/phonenumbers/phonenumber.cc"
  "src/phonenumbers/phonenumber.pb.cc"   # Generated by Protocol Buffers.
  "src/phonenumbers/phonenumberutil.cc"
  "src/phonenumbers/regex_based_matcher.cc"
  "src/phonenumbers/regexp_cache.cc"
  "src/phonenumbers/shortnumberinfo.cc"
  "src/phonenumbers/string_byte_sink.cc"
  "src/phonenumbers/stringutil.cc"
  "src/phonenumbers/unicodestring.cc"
  "src/phonenumbers/utf/rune.c"
  "src/phonenumbers/utf/unicodetext.cc"
  "src/phonenumbers/utf/unilib.cc"
)

if (BUILD_GEOCODER)
  set (
    GEOCODING_SOURCES
    "src/phonenumbers/geocoding/area_code_map.cc"
    "src/phonenumbers/geocoding/default_map_storage.cc"
    "src/phonenumbers/geocoding/geocoding_data.cc"
    "src/phonenumbers/geocoding/mapping_file_provider.cc"
    "src/phonenumbers/geocoding/phonenumber_offline_geocoder.cc"
    "src/phonenumbers/phonenumber.pb.h"  # Forces proto buffer generation.
  )
endif ()

# Add regexp engine-dependent sources. ICU is used by default.
if (USE_RE2)
  # Add a flag to select the right regexp factory implementation used by
  # regexp_factory.h and regexp_adapter_test.cc.
  # When both ICU regexp and RE2 are defined, the regexp engine adapter defaults
  # to RE2 unless the ICU implementation is instantiated explictly obviously.
  add_definitions ("-DI18N_PHONENUMBERS_USE_RE2")
  list (APPEND SOURCES "src/phonenumbers/regexp_adapter_re2.cc")
endif ()

if (USE_ICU_REGEXP)
  add_definitions ("-DI18N_PHONENUMBERS_USE_ICU_REGEXP")
  list (APPEND SOURCES "src/phonenumbers/regexp_adapter_icu.cc")
  # The phone number matcher needs ICU.
  list (APPEND SOURCES "src/phonenumbers/phonenumbermatch.cc")
  list (APPEND SOURCES "src/phonenumbers/phonenumbermatcher.cc")
  if (USE_ALTERNATE_FORMATS)
    list (APPEND SOURCES "src/phonenumbers/alternate_format.cc")
  endif ()
endif ()

# Library sources excluding the metadata files, since special metadata is used
# for unit-testing. Note that a single testing library is built for both
# libphonenumber and geocoding.
set (TESTING_LIBRARY_SOURCES ${SOURCES})
if (BUILD_GEOCODER)
  list (APPEND TESTING_LIBRARY_SOURCES ${GEOCODING_SOURCES})
endif ()

# Add metadata code generation targets.

# This function is invoked to create metadata, test metadata and lite metadata
# code generation targets.
function (add_metadata_gen_target TARGET_NAME XML_FILE METADATA_TYPE METADATA_HEADER)
  set (METADATA_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src/phonenumbers")
  set (GEN_OUTPUT "${METADATA_SOURCE_DIR}/${METADATA_TYPE}.cc" "${METADATA_SOURCE_DIR}/${METADATA_HEADER}.h")
  set (JAR_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../tools/java/cpp-build/target")
  set (JAR_PATH "${JAR_PATH}/cpp-build-1.0-SNAPSHOT-jar-with-dependencies.jar")

  if (REGENERATE_METADATA)
    add_custom_command (
      COMMAND ${JAVA_BIN} -jar
        ${JAR_PATH} BuildMetadataCppFromXml ${XML_FILE}
        ${CMAKE_CURRENT_SOURCE_DIR}/src/phonenumbers ${METADATA_TYPE}

      OUTPUT ${GEN_OUTPUT}
      DEPENDS ${XML_FILE}
    )
  else ()
    add_custom_command (
      COMMAND echo "skip metadata generation from"
        ${XML_FILE} "to"

=== tools/cpp/CMakeLists.txt ===
# Copyright (C) 2012 The Libphonenumber Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Author: Patrick Mezard

cmake_minimum_required (VERSION 3.11)

project (generate_geocoding_data)

set (
  SOURCES
  "src/cpp-build/generate_geocoding_data.cc"
  "src/cpp-build/generate_geocoding_data_main.cc"
)

if (NOT WIN32)
  add_definitions ("-Wall -Werror")
endif ()

include_directories ("src")

add_executable (generate_geocoding_data ${SOURCES})
target_link_libraries (generate_geocoding_data absl::strings absl::btree absl::node_hash_set)

if (BUILD_TESTING)
  set (TEST_SOURCES
      "src/cpp-build/generate_geocoding_data.cc"
      "test/cpp-build/generate_geocoding_data_test.cc"
      "test/cpp-build/run_tests.cc"
  )

  set (TEST_LIBS ${GTEST_LIB})

  if (NOT WIN32)
    list (APPEND TEST_LIBS pthread)
  endif ()

  # Build the testing binary.
  include_directories ("test")
  add_executable (generate_geocoding_data_test ${TEST_SOURCES})
  target_link_libraries (generate_geocoding_data_test absl::btree ${TEST_LIBS} absl::node_hash_set)
endif()

=== debian/changelog ===
libphonenumber (8.13.51+ds-4.2ubuntu1) questing; urgency=medium

  * cpp/tests/phonenumberutil_test.cc : escape bidirectional unicode
    character to fix FTBFS  due to gcc-15 and -Werror=bidi-char=
    (LP: #2124964)

 -- John Chittum <john.chittum@canonical.com>  Tue, 23 Sep 2025 09:24:34 -0400

libphonenumber (8.13.51+ds-4.2build1) questing; urgency=medium

  * Rebuild against latest abseil

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 03 May 2025 11:12:49 -0400

libphonenumber (8.13.51+ds-4.2) unstable; urgency=medium

  * Non-maintainer upload.

  [ Matthias Klose ]
  * libphonenumber-dev: Explicitly depend on libicu-dev. (Closes: #1101095)

 -- Bastian Germann <bage@debian.org>  Sun, 23 Mar 2025 17:37:53 +0100

libphonenumber (8.13.51+ds-4.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Matthias Klose ]
  * Don't explicitly build with c++14 standard. (Closes: #1092351)

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 15 Mar 2025 12:32:09 +0100

libphonenumber (8.13.51+ds-4) unstable; urgency=medium

  * d/rules: Do not compress .xml files

 -- Matthias Geiger <werdahias@debian.org>  Mon, 09 Dec 2024 09:04:57 +0100

libphonenumber (8.13.51+ds-3) unstable; urgency=medium

  * Team upload.
  * Reinstate t64 Provides:

 -- Matthias Geiger <werdahias@debian.org>  Mon, 09 Dec 2024 00:08:07 +0100

libphonenumber (8.13.51+ds-2) unstable; urgency=medium

  * Team upload.
  * Source-only upload

 -- Matthias Geiger <werdahias@debian.org>  Sun, 08 Dec 2024 23:30:13 +0100

libphonenumber (8.13.51+ds-1) unstable; urgency=medium

  * Team upload
  * New upstream version 8.13.51+ds
  * d/copyright: Update Files-Excluded list for new upstream
  * d/p: Refresh for new upstream, drop obsolete patches, cleanup series file
  * d/control: Depend on libgoogle-auto-value-java
  * libphonenumber-dev: Stop installing static library; include cmake files
  * d/rules: set hardening=+all
  * Updated lintian-overrides file for libphonenumber8-java
  * d/rules: Directly build with C++ 14; drop obsolete patch for this
  * Add d/u/metadata file
  * Set DEP-3 header for patches whose origin is clear
  * Ship resources/* in a libphonenumber-data package (Closes: #1089205)
  * d/gbp.conf: Add postimport section
  * Add d/salsa-ci.yml
  * Bump Standards-Version to 4.7.0; no changes needed
  * d/copyright: Update for new upstream

 -- Matthias Geiger <werdahias@debian.org>  Sun, 08 Dec 2024 23:27:38 +0100

libphonenumber (8.12.57+ds-4) unstable; urgency=medium

  * Team upload.
  * Use C++14 to resolve FTBFS with googletest 1.13.0 (Closes: #1041075)
    Thank you to Adrian Bunk for the patch

 -- tony mancill <tmancill@debian.org>  Wed, 19 Jul 2023 21:36:41 -0700

=== debian/control ===
Source: libphonenumber
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Java Maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders: Fredrik Roubert <roubert@google.com>
Build-Depends:
  cmake,
  debhelper-compat (= 13),
  dh-sequence-javahelper,
  default-jdk,
  default-jdk-doc,
  dpkg-dev (>= 1.22.5),
  libabsl-dev,
  libgtest-dev,
  libicu-dev,
  libprotobuf-dev,
  libre2-dev,
  maven-debian-helper,
  protobuf-compiler,
  junit4,
  libbuild-helper-maven-plugin-java,
  libgoogle-auto-value-java,
  libmaven-antrun-plugin-java,
  libmaven-assembly-plugin-java,
  libmaven-compiler-plugin-java,
  libmaven-exec-plugin-java,
  libmaven-jar-plugin-java,
  libmaven-javadoc-plugin-java,
  libmaven-war-plugin-java,
  libmaven-bundle-plugin-java,
  libmockito-java,
  libprotobuf-java,
  libservlet-api-java
Standards-Version: 4.7.0
Section: libs
Homepage: https://github.com/googlei18n/libphonenumber/
Vcs-Browser: https://salsa.debian.org/debian/libphonenumber
Vcs-Git: https://salsa.debian.org/debian/libphonenumber.git
Rules-Requires-Root: no
Description: parsing/formatting/validating phone numbers
 Google's common C++ and Java library for parsing, formatting, storing and
 validating international phone numbers.

Package: libphonenumber8-java
Section: java
Architecture: all
Conflicts: libphonenumber7-java,
Replaces: libphonenumber7-java,
Depends: ${misc:Depends}, ${maven:Depends}
Recommends: ${maven:OptionalDepends}
Description: ${source:Synopsis} - java
 ${source:Extended-Description}
 .
 This package contains the runtime library JARs for Java users.

Package: libphonenumber-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libphonenumber8 (= ${binary:Version}),
  libgeocoding8 (= ${binary:Version}),
  ${misc:Depends},
  ${protobuf:API},
  libboost-thread-dev,
  libabsl-dev,
  libicu-dev,
Description: ${source:Synopsis} - development files
 ${source:Extended-Description}
 .
 This package contains the static libraries and include files.

Package: libphonenumber8
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: ${libphonenumber:Provides}
Multi-Arch: same
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package contains the runtime libraries for C++ users.

Package: libphonenumber-data
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ${source:Synopsis} - data files
 .
 This package provides the data files for libphonenumber,
 such as carrier files.

Package: libgeocoding8
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: geocoding phone numbers
 Google's library for geocoding phone international phone numbers.
 .
 This package contains the runtime libraries which can be used to geocode phone
 numbers. This means obtaining a description (for example of the location) of a
 given phone number.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_ARCH_BITS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

# see #980423
# extract the protobuf API version package and add it to d/control
# Needed because protobuf generated headers are only compatible with that version
protobufapi := $(shell dpkg-query -W -f '$${Provides}' libprotobuf-dev | grep -o 'protobuf-api-[^ ]*')

# virtual package to represent libphonenumber and protobuf ABI
protobufabi := $(shell dpkg-query -W -f '$${Depends}' libprotobuf-dev | sed -n 's/.*libprotobuf\([0-9]*\)\(t64\)\? .*/\1/p')
phonenumberprotoabi := libphonenumber8t64-protobuf$(protobufabi)
ifneq (,$(filter 64,$(DEB_HOST_ARCH_BITS))$(filter i386,$(DEB_HOST_ARCH)))
  phonenumberprotocompatabi := , libphonenumber8-protobuf$(protobufabi)
endif

execute_before_dh_gencontrol:
	echo 'libphonenumber:Provides=$(phonenumberprotoabi)$(phonenumberprotocompatabi)' >> debian/libphonenumber8.substvars
	echo 'protobuf:API=$(protobufapi)' >> debian/libphonenumber-dev.substvars

override_dh_makeshlibs:
	dh_makeshlibs -plibphonenumber8 -V '$(phonenumberprotoabi)'
	dh_makeshlibs --remaining-packages

# workaround cpp lib (arch any) depending on java lib (arch all)
override_dh_auto_configure:
	DH_INTERNAL_OPTIONS= dh_auto_configure -i -plibphonenumber8-java
	dh_auto_configure --sourcedirectory=cpp -- -DUSE_BOOST=OFF

# disable parallelism during build in an attempt to resolve build failures
# see: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1003972#51
override_dh_auto_build:
	DH_INTERNAL_OPTIONS= dh_auto_build -i -plibphonenumber8-java
	ln -sf cpp-build-1.0-SNAPSHOT.jar tools/java/cpp-build/target/cpp-build-1.0-SNAPSHOT-jar-with-dependencies.jar
	ln -sf /usr/share/java/protobuf.jar tools/java/cpp-build/target/protobuf-java-debian.jar
	dh_auto_build --sourcedirectory=cpp --no-parallel

override_dh_auto_test-arch:
	dh_auto_test --sourcedirectory=cpp

override_dh_auto_install-arch:
	dh_auto_install --sourcedirectory=cpp

override_dh_auto_clean-arch:
	dh_auto_clean --sourcedirectory=cpp

# Do not compress PhoneNumberMetadata.xml as we need it uncompressed
override_dh_compress:
	dh_compress -X.xml

=== debian/watch ===
version=4
opts="repacksuffix=+ds,dversionmangle=s/\+ds//,repack" \
    https://github.com/googlei18n/libphonenumber/tags \
    .*/libphonenumber/archive/.*?(\d[\d\.]+).*\.tar\.gz
